/*****************************************************************************

  COPYRIGHT (c) 1995
  THE BOARD OF TRUSTEES OF THE LELAND STANFORD JUNIOR UNIVERSITY
  ALL RIGHTS RESERVED

  No duplications, whole or partial, manual or electronic, may be made
  without the express permission of the author. Any such copies, or
  revisions thereof, must display this notice unaltered.

  Robotics Laboratory,
  Computer Science Department,
  Stanford University

  Original author: 
  Lydia Kavraki (kavraki@cs.stanford.edu)

******************************************************************************/


#include "defs.h"


void convert_cutoff(no_inter, new_no_inter,
                          inter_p, new_inter_p,
                          components, new_final_comp, 
			  in_component,
                          graph, new_graph, cut_off)
int 		no_inter, *new_no_inter;
configuration 	inter_p[MAX_INTER], new_inter_p[MAX_INTER];
int		components, *new_final_comp;
int 		in_component[MAX_INTER];
cellp		*graph[MAX_INTER], *new_graph[MAX_INTER];
int		cut_off;
{
	int 	count, comp_found;
	int	i, j, c;
	int	new_number[MAX_INTER];
	int	num_comp[MAX_COMP_INITIAL];
	int	to_discard[MAX_COMP_INITIAL];
	cellp	*tmp;

		/*make sure we have alocate enough space*/
	if(components>MAX_COMP_INITIAL) {
	 printf("More than MAX_COMP_INITIAL connected comps found (%d) \n",
			components); 
	 exit(-1);
	}

		/*make zero all the counts of the components*/
	for(i=0; i<components; i++) { 
	 num_comp[i] = 0;
	 to_discard[i] = 0;
	}

		/*find the number of elements in each component*/
	for(i=0; i<no_inter; i++) num_comp[in_component[i]]++;

		/*discard small components*/
	for(i=0; i<components; i++) 
	 if(num_comp[i]<cut_off) to_discard[i] = 1;

		/*now isolate the elements that are not alone*/
	count = 0;
	for(i=0; i<no_inter; i++) { 
	 c = in_component[i];
	 if(/*(!graph[i]) ||*/ (to_discard[c])) { 
	  new_number[i] = -1;
	 }
	 else new_number[i] = count++;
	}
	printf ("New count %d\n", count);
	
		/*now build the new structure*/
	init_store_str(new_graph, count);
	*new_no_inter = count; 

		/*build the graph*/
	count = 0;
	for(i=0; i<no_inter; i++) {
	 if(new_number[i] != -1) {
	  assign_conf(inter_p[i], new_inter_p[count]);
	  new_graph[count++] = graph[i];
	  tmp = graph[i];
		/*needs abit fixing*/
	  while(tmp) {
	   tmp->final = new_number[tmp->final];
	   tmp = tmp->next;
	  }
	 }
	}

	printf("New inter and paths kept have been found.\n");
	*new_final_comp = connected_components(new_graph, *new_no_inter, 
					in_component);
         
	printf("Number of connected components %d\n", *new_final_comp);
	if(*new_final_comp>MAX_COMP) {
	 printf("Error: more than MAX_COMP components produced.\n");
	 exit(-1);
	}
}
