/*****************************************************************************

  COPYRIGHT (c) 1995
  THE BOARD OF TRUSTEES OF THE LELAND STANFORD JUNIOR UNIVERSITY
  ALL RIGHTS RESERVED

  No duplications, whole or partial, manual or electronic, may be made
  without the express permission of the author. Any such copies, or
  revisions thereof, must display this notice unaltered.

  Robotics Laboratory,
  Computer Science Department,
  Stanford University

  Original author:
  Lydia Kavraki (kavraki@cs.stanford.edu)

******************************************************************************/


/***************robot specific **************/

#if FIXED_LINKAGE

extern  void    FK_fixed_linkage();
extern  int     VC_fixed_linkage();
extern  int     out_ws_fixed_linkage();
extern  void    allign_robot_fixed_linkage();
extern  int     auto_collision_fixed_linkage();
extern  void    random_conf_fixed_linkage();
extern  void    draw_robot_fixed_linkage();
extern  void    undraw_robot_fixed_linkage();
extern  int     fill_in_fixed_linkage();
extern  int     connect_fixed_linkage();
extern	int	connect_line2_fixed();
extern	void	deviation_rand_conf_fixed_linkage();

#endif


extern	void	convert_cutoff();
extern	void	construct_wmap();
extern	void	compute_all_potentials();
extern	void	concat();

/****************util_st.c*******************/
extern	void 	init_store_str();
extern	void 	dfs();
extern	int 	connected_components();
extern	void	set_store_str();
extern	void	set_store_str_old();
extern	int	read_store_str();
extern	int	get_path();
extern	void	write_graph_and_paths();
extern	void	read_graph_and_paths();



/****************util.c********************/

	
extern 	void    read_obstacles_robot();
extern 	void	read_path();
extern  void 	write_path();
extern	void	write_cspace();
extern	void	read_cspace();
extern  void	write_potentials();
extern  void	read_potentials();
extern  void	write_distance();
extern  void	read_distance();
extern	void	read_graph();
extern 	void	write_graph();


/*****************smooth.c*******************/

extern	void smooth4();

/***************preprocess.c	*************/

extern 	void 	preprocess();
extern	void	construct_cspace();

/***************graphics.c ******************/

extern	void 	draw_workspace();
extern	void 	draw_skeleton();
extern	void	draw_workspace_map();

/*************** other ******************/
extern	void 	bcopy();




extern	configuration	Begin_pos, End_pos;
extern	int		Num_cntl_points;
extern	int 		Cntl_points[NUM_CNTL_POINTS];
extern	int		BaseX, BaseY;
extern	int 		Link_length;
extern	int		Link_vertices;
extern	IPoint		Link[MAX_LINK_VERTICES];
extern	int 		ObjNum;			
extern	int 		ObjectwVertice[MAXOBST];
extern	IPoint		Objectw[MAXVERTEX][MAXOBST];
extern	int		Wspace[DIM][DIM];
extern	int 		Heurpot[NUM_CNTL_POINTS][DIM][DIM], Dist[DIM][DIM];
extern	unsigned int	Cspace[DIM][DIM][DIM/32];
extern	int 		Dim, ThetaDim;
extern	double 		Table_sin[DIM], Table_cos[DIM];
extern	double          Table_sin_length[DIM], Table_cos_length[DIM];

extern	FPoint		FK_inter[MAX_INTER][NBP];
extern	configuration	Inter_p[MAX_INTER];
extern int              No_inter;


	/*these are used as parameters*/

extern	int             Check_init_positions;
extern	int             Pot_type;
extern	int             Close_pot;
extern	int             Time_to_plan;

extern	int             Max_trials_neib;    
extern	int             Max_rand_walk_len;
extern	int             Trials;
extern	int             Max_backtrack;
extern	int             Start_backtrack;
extern	int             Max_rand_walks;

extern	int		Fixed_base;
extern 	int             Read_Workspace;
extern	int             Use_preprocess;


	/*standard defs */
extern  int     atoi();
extern  void    qsort();



	/*external declarations for plan - many duplicates form 
	  the concatenation of files*/
extern	int		Single;
extern cellp           	*Graph[MAX_INTER];
extern int		Check_init_positions;
extern int		Pot_type;
extern int		Close_pot;
extern int	 	Max_trials_neib;	
extern int 		Read_Workspace;
extern int		Use_preprocess;
extern int		Connect_distance;
extern int		Random_connect_length;
extern configuration   Full_path[MAXPATH], Sh_path[MAXPATH], Sm_path[MAXPATH];
extern int             Full_path_len, Sh_path_len, Sm_path_len;
extern	int		Found;
extern double          Timings[10], PostPros_time, Plan_time;
extern int             Lengths[10];
extern  data            Gl_stats[];
extern int             With_interface;
extern char            Input_file_name[100];
extern char            Input_network_name[100];
extern char            Workspace_name[100];
extern char            Path_file_name[100];
extern char            Cspace_fname[100], Dist_fname[100], Pot_fname[100];
extern configuration	C1, C2;
extern int		Query_time;

